    
init python:

    import os.path

    def validateProjectDirectory( directory ):
        if directoryExists(directory):
            return os.path.abspath(directory)
        return ""

    def validProjectName(projectName):
        if projectName == None:
            return False
        return True

    def loadProjectSpecification(projSpec):
        tree = parseXMLFile( projSpec )

        if tree == None: 
            REPORTERROR( "Especificación inválida" )
            return

        root = tree.getroot()

        globals()["projectName"] = getStringAttr(root, 'nombre', None)

        if not validProjectName( globals()["projectName"] ):
            REPORTERROR( "Error en el nombre del proyecto" )
            return

        LOGOK()
        LOG("Recuperando nombre del proyecto: {b}" + globals()["projectName"] + "{/b}")
        LOGOK()


    def parseProjectFile():
        LOG("Leyendo especificación del proyecto en {b}" + globals()["projectSpec"] + '{/b}')
        if fileExists( renpy.loader.transfn( globals()["projectSpec"] ) ):
            loadProjectSpecification( renpy.loader.transfn(globals()["projectSpec"]) )
        else:
            REPORTERROR( "No se encontró la especificación del proyecto" )

    def expandWorkingDirectories():

        projDir = ""
        try:
            projDir = renpy.loader.transfn("") + globals()["projectName"]
            globals()["projectDirectory"] = validateProjectDirectory( projDir )
        except:
            REPORTERROR( "Error en directorio principal del proyecto" )

        globals()["projectScenesDirectory"] = validateProjectDirectory( os.path.join(globals()["projectDirectory"], "scenes" ))
        globals()["projectImagesDirectory"] = validateProjectDirectory( os.path.join(globals()["projectDirectory"], "images" ))
        globals()["projectSoundsDirectory"] = validateProjectDirectory( os.path.join(globals()["projectDirectory"], "sounds" ))
        globals()["projectVoicesDirectory"] = validateProjectDirectory( os.path.join(globals()["projectDirectory"], "voices" ))
        globals()["projectFontsDirectory"]  = validateProjectDirectory( os.path.join(globals()["projectDirectory"], "fonts" ))

        if globals()["projectDirectory"] != "":
            LOG("\n     Principal: " + globals()["projectDirectory"])
        else:
            LOG("\n     Principal: {color=#f00}No se encontró el directorio " + projDir + "{/color}")
        LOG("\n     Escenas: " + globals()["projectScenesDirectory"])
        LOG("\n     Imágenes: " + globals()["projectImagesDirectory"])
        LOG("\n     Sonidos: " + globals()["projectSoundsDirectory"])
        LOG("\n     Voces: " + globals()["projectVoicesDirectory"])
        LOG("\n     Fuentes: " + globals()["projectFontsDirectory"])

        LOGOK()

    def initGC():
        LOGOK()
        parseProjectFile()

        if globals()["lastError"] != None: return

        LOG("Expandiendo directorios...")
        expandWorkingDirectories()


    def validateProjectXMLFiles():
        LOG("Validando documentos XML...")

        if globals()["projectScenesDirectory"] == "":
            REPORTERROR("No se encontró ninguna escena que procesar")
            return

        for doc in globals()["xmlNames"]:
            filePath = globals()["projectScenesDirectory"] + "/" + globals()["xmlNames"][doc]
            if not fileExists( filePath ):
                LOG("\n     Advertencia: No se encontró el documento " + globals()["xmlNames"][doc])
                continue

            if not validateXMLFile( filePath ): 
                REPORTERROR("El documento '" + globals()["xmlNames"][doc] + "' contiene errores de sintaxis.")
                return

            globals()["xmlDocs"][ doc ] = filePath

        LOGOK()
