
init python:

    class Animation(object):
        def __init__(self, xmlNode):

            self.id = getStringAttr(xmlNode, "id")

            self.parsingTable = {
                'cuadro' : [ ('fuente',TXMLStr), ('duracion',TXMLFloat) ],
                'repetir' : [ ]
            }
            self.frames = []
            self.parseFrames(xmlNode)

        def parseFrames(self, xmlNode):
            for child in xmlNode:

                if not child.tag in self.parsingTable:
                    continue

                frame = parseAttributes( child, self.parsingTable )
                #if frame != {}:
                self.frames.append( (child.tag, frame) )

        def generate(self):
            f = []
            writeLine(f, "image " + self.id + ":", 1)
            frameCount = 0
            for name, attrib in self.frames:
                if name == "repetir":
                    writeLine(f, 'repeat', 2)
                    continue

                frame = attrib

                if frame["fuente"] == None:
                    continue                
                writeLine(f, '"' + frame["fuente"] + '"', 2)
                
                requestResource( frame["fuente"] )

                if frame["duracion"] != None:
                    writeLine(f, "pause " + str(frame["duracion"]), 2)
                else:
                    writeLine(f, "pause 0.15", 2)
                frameCount += 1

            # ignore animations without frames
            if frameCount == 0:
                f = []

            return f

