
init python:

    class Widget(object):

        BASE = 0
        BUTTON = 1
        TEXTAREA = 2
        CONFIGURATION = 3
        LABEL = 4
        IMAGE = 5
        MUSIC = 6
        IMAGEHORIZONTALSLICE = 7
        SECTIONSELECTOR = 8

        def __init__(self, xmlNode):
            self.id = "widgetDefault"
            self.type = Widget.BASE
            self.events = {}
            self.attributes = {}
            
            # for textarea and extras
            self.lines = []

            self.parsingTable = {
                'boton' : [ ('id', TXMLStr), ('fuente',TXMLStr), ('fuenteResaltado', TXMLStr), ('x',TXMLInt), ('y',TXMLInt) ],
                'areaDeTexto' : [ ('id', TXMLStr) ],
                'configuracion' : [ ('id', TXMLStr), ('titulo',TXMLStr), ('colorTexto', TXMLStr), ('colorFondo', TXMLStr) ],
                'etiqueta' : [ ('id', TXMLStr), ('texto',TXMLStr), ('datos',TXMLStr), ('x',TXMLInt), ('y',TXMLInt), ('extra', TXMLStr) ],
                'imagen' : [ ('id', TXMLStr), ('fuente',TXMLStr), ('x',TXMLInt), ('y',TXMLInt), ('transformacion', TXMLStr) ],
                'musica' : [ ('id', TXMLStr), ('fuente',TXMLStr) ],
                'imagenCorteHorizontal' : [ ('id', TXMLStr), ('fuente',TXMLStr), ('datos',TXMLStr), ('x',TXMLInt), ('y',TXMLInt) ],
                'selectorSecciones' : [ ('id', TXMLStr), ('fuente',TXMLStr), ('fuenteResaltado', TXMLStr), ('columnas', TXMLInt), ('x',TXMLInt), ('y',TXMLInt) ]
            }

            self.typeTable = {
                'boton' : Widget.BUTTON,
                'areaDeTexto' : Widget.TEXTAREA,
                'configuracion' : Widget.CONFIGURATION,
                'etiqueta' : Widget.LABEL,
                'imagen' : Widget.IMAGE,
                'musica' : Widget.MUSIC,
                'imagenCorteHorizontal' : Widget.IMAGEHORIZONTALSLICE,
                'selectorSecciones' : Widget.SECTIONSELECTOR
            }

            self.parse(xmlNode)

        def parse(self, xmlNode):

            if not xmlNode.tag in self.parsingTable:
                return

            self.type = self.typeTable[ xmlNode.tag ]

            self.attributes = parseAttributes(xmlNode, self.parsingTable)

            self.id = self.attributes[ 'id' ]

            for child in xmlNode:
                if child.tag == 'evento':
                    event = EventListener( child ) 
                    if event == None: continue
                    self.events[ event.id ] = event
                elif child.tag == 'linea':
                    self.lines.append( ( getStringAttr(child, 'texto'), getStringAttr(child, 'extra')) )
