# `Maestro Virtual' una novela visual que relata el 
# cuento `El Principe Feliz' de Oscar Wilde.
# Copyright (C) 2010 Fundación CENDITEL.

# La Fundación CENDITEL concede permiso para copiar, distribuir 
# y/o modificar este programa bajo los términos de la licencia de
# software GPL versión 2.0 de la Free Software Foundation. 

# Este programa se distribuye con la esperanza de que sea útil, 
# pero SIN NINGUNA GARANTÍA; tampoco las implícitas garantías
# de MERCANTILIDAD o ADECUACIÓN A UN PROPÓSITO PARTICULAR. 
# Consulte la licencia GPL para más detalles.

# Una copia de la licencia en inglés y en español puede obtenerse 
# en los siguientes sitios en Internet:
# En inglés: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# En español: http://www.es.gnu.org/modules/content/index.php?id=8

transform dict_transform:
    ypos 450 yanchor 1.0 xpos 0 xanchor 0

    on replace:
        crop (0, 0, 800, 150)
            
    on show:
        crop (0, 0, 800, 0)
        linear .5 crop (0, 0, 800, 150)

    on hide:
        linear .5 crop (0, 0, 800, 0)

init python:

    import re
    
    correctedWords = {}
    
    class __DictionaryWindow(object):

        def predict(self, callback):
            return
        
        def parameterize(self, name, args):

            msg = u'\nQuizás quisiste decir:\n'
            navOrder = correctedWords.keys()
            navOrder.sort()

            for ex in navOrder:
                msg = msg + u'   {color=#840}"' + correctedWords[ex] + u'"{/color} en lugar de "' + ex + u'"\n'
            
            ct = Text(msg, size=16, color="#000")
            vp = Viewport(ct, child_size=(2000, 2000), ymaximum=450, draggable=True, mousewheel=True)
            w = Window(vp, background = "#fffc", top_padding=0, left_padding=10, right_padding=10, bottom_padding=0, yminimum=0)            
            return dict_transform(w)

image dictionaryWindow = __DictionaryWindow()