
init python:

    class Transform(object):
        def __init__(self, xmlNode):

            self.id = getStringAttr(xmlNode, "id")

            self.parsingTable = {
                'xanchor' : [ ('val',TXMLStr) ],
                'yanchor' : [ ('val',TXMLStr) ],
                'xpos' : [ ('val',TXMLStr) ],
                'ypos' : [ ('val',TXMLStr) ],
                'xalign' : [ ('val',TXMLStr) ],
                'yalign' : [ ('val',TXMLStr) ],
                'alpha' : [ ('val',TXMLStr) ],
                'zoom' : [ ('val',TXMLStr) ],
                'pause' : [ ('val',TXMLStr) ],
                'repeat' : [],
                'function' : [ ('val',TXMLStr) ],
                'any' : [ ('val',TXMLStr) ],
                'linear' : [ ('t',TXMLStr), ('xpos', TXMLStr), ('ypos', TXMLStr), ('alpha', TXMLStr), ('zoom', TXMLStr), ('xalign', TXMLStr), ('yalign', TXMLStr) ],
                'easein' : [ ('t',TXMLStr), ('xpos', TXMLStr), ('ypos', TXMLStr), ('alpha', TXMLStr), ('zoom', TXMLStr), ('xalign', TXMLStr), ('yalign', TXMLStr) ],
                'easeout' : [ ('t',TXMLStr), ('xpos', TXMLStr), ('ypos', TXMLStr), ('alpha', TXMLStr), ('zoom', TXMLStr), ('xalign', TXMLStr), ('yalign', TXMLStr) ],
            }
            self.commands = []
            self.parseCommands(xmlNode)

        def parseCommands(self, xmlNode):
            for child in xmlNode:
                command = parseAttributes( child, self.parsingTable )
                #if command != {}:
                self.commands.append( (child.tag, command) )
            #raise Exception( self.commands )

        def generate(self):
            f = []
            writeLine(f, "transform " + self.id + ":", 1)
            trCount = 0

            for commandName, commandAttrib in self.commands:

                if not commandName in self.parsingTable:
                    continue
                
                if commandName == "repeat":
                    writeLine(f, "repeat", 2)
                    continue

                if commandName == 'any':
                    writeLine(f, commandAttrib['val'], 2)
                elif commandName in ['linear', 'easein', 'easeout']:
                    s = ""
                    for attrib in commandAttrib:
                        if commandAttrib[attrib] == None or attrib == 't':
                            continue
                        s = s + ' ' + attrib + ' ' + commandAttrib[attrib]
                    if s == "": 
                        continue
# TODO: Asegurar que atribute 't' es != None
                    writeLine(f, commandName + ' ' + commandAttrib['t'] + s, 2)
                else:
                    writeLine(f, commandName + ' ' + commandAttrib['val'], 2)

                trCount += 1
                    
            # ignore transforms without commands
            if trCount == 0:
                f = []

            return f

