
init python:
    
    import xml.etree.ElementTree as ET

    TXMLInt = 0
    TXMLFloat = 1
    TXMLStr = 2

    def openFile(filename):
        return open( renpy.loader.transfn(filename), "r" )
    
    def parseXMLFile(filename):
        try:
            #if not renpy.exists( filename ):
            #    return None
            #return ET.parse( renpy.loader.transfn(filename) )
            return ET.parse(filename)
        except:
            return None

    def getIntAttr(xmlNode, attrib, default=0):
        if not attrib in xmlNode.attrib:
            return default
        try:
            result = int(xmlNode.attrib.get(attrib))
        except:
            result = default
        return result

    def getStringAttr(xmlNode, attrib, default=""):
        if not attrib in xmlNode.attrib:
            return default
        return xmlNode.attrib.get(attrib)

    def getFloatAttr(xmlNode, attrib, default=0.0):
        if not attrib in xmlNode.attrib:
            return default
        try:
            result = float(xmlNode.attrib.get(attrib))
        except:
            result = default
        return result

    def parseAttributes(xmlNode, parsingTable):
        attributes = {}

        if not xmlNode.tag in parsingTable:
            return {}

        parsingEntities = parsingTable[ xmlNode.tag ]
        for entity, entityType in parsingEntities:
            if entityType == TXMLInt:
                attributes[entity] = getIntAttr(xmlNode, entity, None)
            elif entityType == TXMLFloat:
                attributes[entity] = getFloatAttr(xmlNode, entity, None)
            elif entityType == TXMLStr:
                attributes[entity] = getStringAttr(xmlNode, entity, None)

        return attributes

    def validateXMLFile( filename ):
        try:
            ET.parse( filename )
            return True
        except:
            return False


