

init python:
    
    import pygame
    import random
    
    #############################################################
    # MCards
    # Flipping cards
    #############################################################
    class CCards(renpy.Displayable):

        #############################################################
        def __init__(self, **kwargs):

            renpy.Displayable.__init__(self, **kwargs)
                       
            # listen to events?
            self.sensitive = True
            
            # objects
            self.cards = [ ]

            self.currentCard = None
            self.currentPairValue = -1            
            self.currentPairCard = None
            self.unmatchedPairCard = None
            
            self.flashCounter = 0
            
            self.offx = 50
            self.offy = 48
            self.max_xcord = 501
            self.xgap = 150
            self.ygap = 150
            
        #############################################################
        def show(self, layer='master'):
            pass            
            
        #############################################################
        def hide(self, layer='master'):
            pass

        #############################################################
        def addCardPair(self, cardFace, cardBackFace, cardWidth, cardHeight, cardValue):
            card1 = dict( cardFace = renpy.easy.displayable_or_none(cardFace), cardBackFace = renpy.easy.displayable_or_none(cardBackFace), x = 0, y = 0, width = cardWidth, height = cardHeight, reversed = False, value = cardValue) 
            card2 = dict( cardFace = renpy.easy.displayable_or_none(cardFace), cardBackFace = renpy.easy.displayable_or_none(cardBackFace), x = 0, y = 0, width = cardWidth, height = cardHeight, reversed = False, value = cardValue) 
            self.cards.append( card1 )
            self.cards.append( card2 )
       
        #############################################################        
        def shuffle(self):
            random.shuffle(self.cards)
            xcord = 50
            ycord = 50
            for card in self.cards:
                card['x'] = xcord + self.offx
                card['y'] = ycord + self.offy
                xcord += self.xgap
                if xcord > self.max_xcord:
                    xcord = 50
                    ycord += self.ygap

        #############################################################        
        def checkSolution(self):
            if len(self.cards) == 0:
                return 1
            return 0

        #############################################################
        def render(self, width, height, st, at):

            # get render object
            rv = renpy.Render(width, height)
                    
            for card in self.cards:
                    if card['reversed'] == True and card['cardFace'] != None:
                        surf = renpy.render( card['cardFace'], width, height, st, at)
                        rv.blit(surf, (card['x'], card['y']))
                    elif card['reversed'] == False and card['cardBackFace'] != None:
                        surf = renpy.render( card['cardBackFace'], width, height, st, at)
                        rv.blit(surf, (card['x'], card['y']))

            return rv
        
        #############################################################
        def event(self, ev, x, y, st):           
            
            if ev.type == pygame.USEREVENT + 1:
                self.sensitive = True
                pygame.time.set_timer(pygame.USEREVENT + 1, 0)                
                if self.unmatchedPairCard != None:
                    self.currentPairCard['reversed'] = False
                    self.unmatchedPairCard['reversed'] = False
                    self.currentCard = None
                    self.currentPairCard = None
                    self.unmatchedPairCard = None
                    self.currentPairValue = -1
                renpy.redraw(self,0)
                return
            elif ev.type == pygame.USEREVENT + 2:
                self.currentCard['x'] = 2000 - self.currentCard['x']
                self.currentCard['y'] = 2000 - self.currentCard['y']
                self.currentPairCard['x'] = 2000 - self.currentPairCard['x']
                self.currentPairCard['y'] = 2000 - self.currentPairCard['y']                
                renpy.redraw(self,0)
                self.flashCounter += 1
                if self.flashCounter > 10:                    
                    pygame.time.set_timer(pygame.USEREVENT + 2, 0)
                    self.cards.remove(self.currentCard)
                    self.cards.remove(self.currentPairCard)
                    self.currentCard = None
                    self.currentPairCard = None
                    self.unmatchedPairCard = None
                    self.currentPairValue = -1
                    solved = self.checkSolution()
                    self.sensitive = True
                    if solved == 1:
                        self.sensitive = False
                        return 1
                        
            if not self.sensitive:
                return
        
            if ev.type == pygame.MOUSEBUTTONDOWN and ev.button == 1:
                
                # debug return
                #return 1
                
                for card in list(reversed(self.cards)):
                    if card['reversed'] == False and inRect(x, y, (card['x'], card['y'], card['width'], card['height']) ):
                        card['reversed'] = True
                        renpy.music.play('sounds/carta.ogg', channel='sound')
                        if card['value'] == self.currentPairValue:
                            self.sensitive = False
                            self.currentCard = card
                            self.flashCounter = 0
                            renpy.music.play('sounds/sonido_logro.ogg', channel='sound', fadeout=0)
                            pygame.time.set_timer(pygame.USEREVENT + 2, 100)
                        else:
                            if self.currentPairCard == None:
                                self.currentPairCard = card
                                self.currentPairValue = card['value']
                            else:
                                self.unmatchedPairCard = card
                                self.sensitive = False
                                pygame.time.set_timer(pygame.USEREVENT + 1, 1200)
                        renpy.redraw(self,0)
                        return

                
    #############################################################
    #############################################################
    #############################################################
