# `Maestro Virtual' una novela visual que relata el 
# cuento `El Principe Feliz' de Oscar Wilde.
# Copyright (C) 2010 Fundación CENDITEL.

# La Fundación CENDITEL concede permiso para copiar, distribuir 
# y/o modificar este programa bajo los términos de la licencia de
# software GPL versión 2.0 de la Free Software Foundation. 

# Este programa se distribuye con la esperanza de que sea útil, 
# pero SIN NINGUNA GARANTÍA; tampoco las implícitas garantías
# de MERCANTILIDAD o ADECUACIÓN A UN PROPÓSITO PARTICULAR. 
# Consulte la licencia GPL para más detalles.

# Una copia de la licencia en inglés y en español puede obtenerse 
# en los siguientes sitios en Internet:
# En inglés: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# En español: http://www.es.gnu.org/modules/content/index.php?id=8

####
init python:
    
    import re
    
    def validateNL(text, id):

        accept = []
        weightBound = 0.9
        
        # SECTION 1 ####################################################################################
        if id == "ask-obj-veleta":
            accept = [ (u"veleta", 1.0) ]

        elif id == "ask-obj-rubi":
            accept = [ (u"rubí", 1.0) ]

        elif id == "ask-obj-columna":
            accept = [ (u"columna", 1.0) ]

        elif id == "ask-obj-zafiro":
            accept = [ (u"zafiro", 1.0) ]
        
        elif id == "ask-obj-catedral":
            accept = [ (u"catedral", 1.0) ]

        # SECTION 2 ####################################################################################
        elif id == "ask-golondrina-egipto":
            # si hay una preposición como "a" o "para" la palabra que debe seguir obligatoriamente debe ser "Egipto". Para evitar cosas como "iba para China". Aunque igual nos queda el problema de "iba para el país de Egipto".
            accept = [ (u"iba", 1.0),  (u"no iba", -1.0), (u"no estaba en egipto", 1.0) ]
        
        elif id == "ask-migracion":
            accept = [ (u"viaj", 1.0) ]
        
        elif id == "ask-dias-6semanas":
            if re.search("( |^)42( |$)", text) != None:
                return 1            
            accept = [ (u" 42 ", 1.0), (u"cuarenta y dos", 1.0)]
                
        elif id == "ask-poligono":
            accept = [ (u"pentágono", 1.0) ]

        
        
        # ACTIVIDAD 7 ####################################################################################
        
        elif id == "pregunta_7":
            accept = [ (u"XxXx0o", 1.0) ]

        
        
        # ACTIVIDAD 10 ####################################################################################
        
        elif id == "pregunta_10a":
            accept = [ (u"La Grita", 1.0), (u"La grita", 1.0), (u"la grita", 1.0), (u"la Grita", 1.0), (u"LA GRITA", 1.0) ]

        elif id == "pregunta_10b":
            accept = [ (u"Estanques", 1.0), (u"estanques", 1.0), (u"ESTANQUES", 1.0) ]
        
        elif id == "pregunta_10c":
            accept = [ (u"Lagunillas", 1.0), (u"lagunillas", 1.0), (u"LAGUNILLAS", 1.0) ]
        
        elif id == "pregunta_10d":
            accept = [ (u"Bailadores", 1.0), (u"bailadores", 1.0), (u"BAILADORES", 1.0) ]
        
        
        
        
        # SECTION 4 ####################################################################################
        elif id == "ask-norteeuropa":
            accept = [ (u"europa", 1.0) ]

        elif id == "ask-idcontinente":
            if selContinente == 0:
                # África
                accept = [ (u"áfrica", 1.0), (u"africano", 1.0) ]
            elif selContinente == 1:
                # América
                accept = [ (u"américa", 1.0), (u"americano", 1.0) ]
            elif selContinente == 2:
                # Europa
                accept = [ (u"europa", 1.0), (u"europeo", 1.0) ]
            elif selContinente == 3:
                # Asia
                accept = [ (u"asia", 1.0), (u"asiático", 1.0) ]
            elif selContinente == 4:
                # Oceanía
                accept = [ (u"oceanía", 1.0), (u"oceánico", 1.0) ]
        
        elif id == "ask-europasuroeste":
            accept = [ (u"portugal", 1.0) ]

        elif id == "ask-europanoreste":
            accept = [ (u"rusia", 1.0) ]            

        elif id == "ask-europanoroeste":
            accept = [ (u"islandia", 1.0) ]

        elif id == "ask-kilometros":
            if re.search("( |^)1000( |$)", text) != None or re.search("( |^)1\.000( |$)", text) != None:
                return 1            
            accept = [ (u"mil", 1.0),  (u" 1000 ", 1.0), (u" 1.000 ", 1.0)]

        elif id == "ask-kilometros700":
            if re.search("( |^)700000( |$)", text) != None or re.search("( |^)700\.000( |$)", text) != None or re.search("( |^)700 mil( |$)", text) != None:
                return 1
            accept = [ (u"setecientos mil", 1.0),  (u" 700000 ", 1.0), (u" 700.000 ", 1.0)]

        elif id == "ask-kilometrosMerida":
            if re.search("( |^)6( |$)", text) != None:
                return 1            
            accept = [ (u" 6 ", 1.0), (u"seis", 1.0)]

        elif id == "ask-mediterraneo":
            accept = [ (u"mediterráneo", 1.0) ]

        elif id == "ask-estatuaDorada":
            accept = [ (u"cubierta de oro", 1.0), (u"revestida de oro", 1.0), (u"oro por encima", 1.0), (u"tenía oro", 1.0), (u"oro encima", 1.0) ]

        elif id == "ask-conocesEstatua":
            # validar por la presencia de palabras claves, y por la cantidad de palabras empleadas.
            accept = [ (u"estatua", 1.0), (u"simón", 1.0), (u"bolívar", 3.0), (u"libertador", 3.0), (u"maría lionza", 3.0), (u"sucre", 3.0), (u"ecuestre", 2.0), (u"prócer", 2.0), (u"patria", 2.0), (u"batalla", 1.0), (u"día", 1.0) ]
            weightBound = 2.9
            if len( text.split(None) ) < 4:                
                return 0
            
        elif id == "ask-lagrimasEstatua":
            accept = [ (u"lágrima", 1.0) ]

        # SECTION 5 ####################################################################################
        elif id == "ask-nilo":
            accept = [ (u"río", 1.0) ]

        elif id == "ask-nilo-km":
            if re.search("( |^)6\.670\.000( |$)", text) != None or re.search("( |^)6670000( |$)", text) != None:
                return 1            
            accept = [ (u" 6.670.000 ", 1.0), (u" 6670000 ", 1.0),  (u"seis millones seiscientos setenta mil", 1.0)]

        elif id == "ask-delta":
            accept = [ (u"terreno", 1.0), (u"lugar", 1.0), (u"parte", 1.0), (u"área", 1.0), (u"zona", 1.0), (u"espacio", 1.0), (u"río", 6.0)]
            weightBound = 6.9

        elif id == "ask-catarata":
            accept = [ (u"cascada", 5.0), (u"caída", 1.0), (u"salto", 1.0), (u"agua", 4.0)]
            weightBound = 4.9
            
        elif id == "ask-molinero":
            accept = [ (u"tiene", 1.0), (u"dueño", 1.0), (u"trabaja", 1.0), (u"molino", 4.0)]
            weightBound = 4.9
            
        elif id == "ask-hijos-molinero":
            if re.search("( |^)14( |$)", text) != None:
                return 1                        
            accept = [ (u"catorce", 1.0), (u" 14 ", 1.0)]

        # SECTION 6 ####################################################################################
        elif id == "ask-costurera":
            accept = [ (u"cosiendo", 1.0), (u"cosía", 1.0), (u"cose", 1.0), (u"borda", 1.0) ]

        elif id == "ask-costurera-baile":
            accept = [ (u"sí", 1.0), (u"si", 1.0) ]

        # SECTION 7 ####################################################################################
        elif id == "ask-tela":
            if re.search("( |^)7( |$)", text) != None:            
                return 1                                    
            accept = [ (u" 7 ", 1.0), (u"siete", 1.0) ]

        elif id == "ask-puerto":
            accept = [ (u"barco", 1.0), (u"embarcación", 1.0), (u"bote", 1.0) ]

        # SECTION 8 ####################################################################################
        elif id == "ask-ornitologia":
            accept = [ (u"fenómeno", 1.0), (u"asombr", 1.0), (u"golondrina", 1.0), (u"invierno", 1.0), (u"notable fenómeno", 3.0) ]
            weightBound = 2.9

        elif id == "ask-campanario":
            accept = [ (u"campanas", 1.0) ]

        # SECTION 9 ####################################################################################
        elif id == "ask-gorriones-dimension":
            accept = [ (u"grande", 1.0), (u"pequeño", 1.0) ]

        elif id == "ask-gorriones-hormiga":
            accept = [ (u"grande", 1.0) ]

        elif id == "ask-amigas-golondrina":
            accept = [ (u"golondrinas", 1.0) ]

        elif id == "ask-segunda-catarata":
            accept = [ (u"nilo", 1.0) ]

        elif id == "ask-hipopotamo":
            accept = [ (u"animal", 1.0), (u"mamífero", 1.0), (u"paquidermo", 1.0) ]

        elif id == "ask-hipopotamo-dimension":
            accept = [ (u"grande", 1.0) ]

        elif id == "ask-leones":
            accept = [ (u"animal", 1.0), (u"mamífero", 2.0), (u"carnívoro", 2.0), (u"grande", 1.0), (u"amarill", 1.0), (u"roj", 1.0), (u"fulvo", 1.0), (u"melen", 1.0), (u"fuerte", 1.0) ]
            weightBound = 2.9
            
        # SECTION 10 ####################################################################################
        elif id == "ask-escritor-imprenta":
            accept = [ (u"editor", 1.0), (u"imprenta", 1.0), (u"imprimir", 1.0), (u"impresión", 1.0) ]

        elif id == "ask-violeta":
            accept = [ (u"planta", 1.0), (u"flor", 1.0), (u"morad", 1.0) ]

        elif id == "ask-granada":
            accept = [ (u"fruta", 1.0), (u"grano", 1.0) ]

        elif id == "ask-india":
            accept = [ (u"asia", 1.0), (u"asiático", 1.0) ]

        elif id == "ask-siglos":
            if re.search("( |^)10( |$)", text) != None:
                return 1
            accept = [(u" 10 ", 1.0),  (u"diez", 1.0) ]

        elif id == "ask-cocodrilo":
            accept = [ (u"animal", 1.0), (u"reptil", 3.0), (u"agua", 2.0), (u"grande", 1.0), (u"verd", 2.0), (u"escama", 2.0), (u"río", 2.0) ]
            weightBound = 2.9
            
        elif id == "ask-cocodrilo-hipopotamo":
            accept = [ (u"cocodrilo", 1.0)]

        elif id == "ask-tonelada":
            if re.search("( |^)1\.000( |$)", text) != None or re.search("( |^)1000( |$)", text) != None:            
                return 1                                    
            accept = [ (u" 1.000 ", 1.0), (u" 1000 ", 1.0), (u"mil", 1.0) ]

        elif id == "ask-amigas-nidos":
            accept = [ (u"golondrinas", 1.0)]

        # SECTION 11 ####################################################################################
        elif id == "ask-golondrina-conducta":
            accept = [ (u"quedar", 1.0)]

        # SECTION 12 ####################################################################################
        elif id == "ask-mendigo":
            accept = [ (u"pobre", 1.0), (u"limosna", 1.0), (u"limosnero", 1.0), (u"pordiosero", 1.0)]

        elif id == "ask-principe-mago":
            accept = [ (u"dar", 1.0), (u"regalar", 1.0), (u"entregar", 1.0), (u"repartir", 1.0), (u"oro", 5.0)]
            weightBound = 5.9

        # SECTION 13 ####################################################################################
        elif id == "ask-ninos-pan":
            accept = [ (u"vender", 1.0), (u"oro", 1.0), (u"compra", 1.0), (u"comida", 1.0), (u"pan", 1.0)]
            weightBound = 2.9
            
        # SECTION 14 ####################################################################################
        elif id == "ask-golondrina-comida":
            accept = [ (u"panader", 1.0)]

        elif id == "ask-pan-harina":
            accept = [ (u"harina", 1.0)]

        elif id == "ask-harina-trigo":
            accept = [ (u"molinero", 1.0)]
        
        else:
            raise Exception("no ask handler")

        # Reject if answer includes at least a word which must be capitalized, such as "Europa"
        for word in capitalWords:
            #~ if text.find(word) > -1:
            if re.search("( |^)" + word, text) != None:
                return 0

        text = text.lower()
        
        # Compute input weight
        weightSum = 0
        for (word, weight) in accept:
            #~ if text.find(word) > -1:
            if re.search("( |^)" + word, text) != None:
                weightSum += weight
        if weightSum > weightBound:
            return 1

        return 0
